/***************************************************************************
 *   Copyright (C) 2010 by Consciousness
 *   muwee@gala.net
 *                                                                         
 *   This program is free software; you can redistribute it and/or modify  
 *   it under the terms of the GNU General Public License as published by  
 *   the Free Software Foundation; either version 2 of the License, or     
 *   (at your option) any later version.                                   
 *                                                                         
 *   This program is distributed in the hope that it will be useful,       
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 *   GNU General Public License for more details.                          
 *                                                                         
 *   You should have received a copy of the GNU General Public License     
 *   along with this program; if not, write to the                         
 *   Free Software Foundation, Inc.,                                       
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             
 ***************************************************************************/


#include <QtGui>
#include <QDebug>
#include <kapplication.h>
#include <kconfig.h>
#include <kglobalsettings.h>
#include <kmainwindow.h>
#include <kwindowsystem.h>
#include <kstandarddirs.h>
#include <klineedit.h>
#include <kicontheme.h>
#include "mainwin.h"
#include <qstyleoption.h>

mainwin::mainwin()
{
	defkit = new KIconTheme(KIconTheme::defaultThemeName());
	sett = new QSettings("gtk-kde4", "gtk-kde4");
	fileOpen = false;
	applyApp();
	applyIco();
	connect(KGlobalSettings::self(), SIGNAL(appearanceChanged()), this, SLOT(time()));
	connect(KGlobalSettings::self(), SIGNAL(iconChanged(int)), this, SLOT(applyIco()));
	//connect(KGlobalSettings::self()->, SIGNAL(), this, SLOT(applyIco()));
}

mainwin::~mainwin()
{
	delete sett;
	delete defkit;
	//this->deleteLater();
}

void mainwin::applyApp()
{
	//i must keep this, till  some menu workaround found
	QMenu* menu=new QMenu(this);
	QAction* act1=new QAction(menu);
	QAction* act2=new QAction(menu);
	act1->setFont(QFont("Monospace",24));
	act2->setFont(QFont("Monospace",24));
	act1->setText("             ");
	act2->setText("             ");
	menu->resize(200,200);
	menu->addAction(act1);
	menu->addAction(act2);	
		
	//normal code
	QDir::setCurrent(QDir::homePath().append("/.themes/qt4/gtk-2.0/"));
	pal=this->palette();
	drawWidgets();			//here it is 

	//background
	pix=QPixmap(1,1024);
	pix.fill(pal.color(QPalette::Window));
	pix.save("Toolbar/bg.png",0,100);
	pix=pix.copy(QRect(0,0,1,50));
	pix.save("Toolbar/toolbar.png",0,100);
	pix=pix.copy(QRect(0,0,1,30));
	pix.save("Toolbar/toolbarbg.png",0,100);
	//menu background
	pix=pix.copy(QRect(0,0,1,10));
	pix.save("Menu-Menubar/menubar.png",0,100);

	//pBar
	
	//tbw
	//menubar, menu
	main=QPixmap(23,10);
	main.fill(Qt::transparent);
	menu->show();
	main=QPixmap(menu->size());
	main.fill(Qt::transparent);
	pix=main;
	menu->render(&pix,QPoint(0,0),menu->rect(),QWidget::DrawChildren);
	pix.save("Menu-Menubar/menu.png",0,100);

	//deinitialization
	//delete menu;
	toFile();
	menu->hide();	
}

void mainwin::drawWidgets()
{
	QStyleOptionButton sob;
	QStyleOptionProgressBar sopb;
	QStyleOptionTabV2 sot;
	QStyleOptionSlider sos;
	QStyleOptionMenuItem somi;
	QStyleOptionHeader soh;
	QStyleOptionToolButton sotb;
	QStyleOptionSpinBox spb;
	QStyleOption so;
	QStyleOptionFrame sof;
	QStyleOptionFrameV3 sof3;
	QStyleOptionTabWidgetFrame sotwf;
	QStyleOptionSizeGrip sosg;
	somi.initFrom(this);
	sob.initFrom(this);
	sopb.initFrom(this);
	soh.initFrom(this);
	sos.initFrom(this);
	sot.initFrom(this);
	sotb.initFrom(this);
	so.initFrom(this);
	spb.initFrom(this);
	sof.initFrom(this);
	sotwf.initFrom(this);
	sof3.initFrom(this);
	sosg.initFrom(this);
	
	rota.rotate(90);	//iitialize rotation degree
	
	pix=QPixmap(93,22);
	pix.fill(Qt::transparent);
	QPainter painter(&pix);
	//buttons
	//enabled button
	pix.fill(Qt::transparent);
	sob.state = QStyle::State_Enabled;
	sob.rect=QRect(0,0, 93,22);
	style()->drawControl(QStyle::CE_PushButton, &sob, &painter, this);
	pix.save("Buttons/button-normal.png",0, 100);
	pix.save("Buttons/button-default.png",0, 100);
	pix.save("Combo/combo-normal.png",0, 100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//mouseOver button
	sob.state |= QStyle::State_MouseOver; 
	style()->drawControl(QStyle::CE_PushButton, &sob, &painter, this);
	pix.save("Buttons/button-prelight.png",0, 100);
	pix.save("Combo/combo-prelight.png",0, 100);
	//sob.rect=QRect(5,30, 400,400);
	/*QStylePainter sp(this);
	sp.drawPrimitive(QStyle::PE_PanelButtonCommand);*/
	//painter.end();
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//toggled button
	sob.state = QStyle::State_Sunken; 
	style()->drawControl(QStyle::CE_PushButton, &sob, &painter, this);
	pix.save("Buttons/button-pressed.png",0, 100);
	pix.save("Combo/combo-active.png",0, 100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//disabled button
	sob.palette.setCurrentColorGroup(QPalette::Disabled); 
	sob.state &= ~QStyle::State_Enabled & ~QStyle::State_Sunken;
	style()->drawControl(QStyle::CE_PushButton, &sob, &painter, this);
	pix.save("Buttons/button-insensitive.png",0, 100);
	pix.save("Combo/combo-insensitive.png",0, 100);
	
	painter.end();
	pix=QPixmap(23,23);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	
	//checkBoxes && radioButtons
	sob.palette.setCurrentColorGroup(QPalette::Active); 
	sob.state = QStyle::State_Enabled;
	sob.rect=QRect(0,0, 23,23);
	style()->drawControl(QStyle::CE_CheckBox, &sob, &painter, this);
	pix.save("Check-Radio/check1.png",0,100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	style()->drawControl(QStyle::CE_RadioButton, &sob, &painter, this);
	pix.save("Check-Radio/option1.png",0,100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
		
	//mouseOver check'n'radio
	sob.state |=QStyle::State_MouseOver;
	style()->drawControl(QStyle::CE_CheckBox, &sob, &painter, this);
	pix.save("Check-Radio/check3.png",0,100);	
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	style()->drawControl(QStyle::CE_RadioButton, &sob, &painter, this);
	pix.save("Check-Radio/option3.png",0,100);	
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//disabled check'n'radio
	sob.state &= ~QStyle::State_Enabled; 
	sob.palette.setCurrentColorGroup(QPalette::Disabled); 
	style()->drawControl(QStyle::CE_CheckBox, &sob, &painter, this);
	pix.save("Check-Radio/check5.png",0,100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	style()->drawControl(QStyle::CE_RadioButton, &sob, &painter, this);
	pix.save("Check-Radio/option5.png",0,100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	
	//checked check'n'radio
	sob.palette.setCurrentColorGroup(QPalette::Active); 
	sob.state = QStyle::State_On;
	sob.state |= QStyle::State_Enabled;
	style()->drawControl(QStyle::CE_CheckBox, &sob, &painter, this);
	pix.save("Check-Radio/check2.png",0,100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	style()->drawControl(QStyle::CE_RadioButton, &sob, &painter, this);
	pix.save("Check-Radio/option2.png",0,100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//checked mouseOver check'n'radio
	sob.state |=QStyle::State_MouseOver;
	style()->drawControl(QStyle::CE_CheckBox, &sob, &painter, this);
	pix.save("Check-Radio/check4.png",0,100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	style()->drawControl(QStyle::CE_RadioButton, &sob, &painter, this);
	pix.save("Check-Radio/option4.png",0,100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//checked disabled check'n'radio
	sob.state &= ~QStyle::State_Enabled; 
	sob.palette.setCurrentColorGroup(QPalette::Disabled); 
	style()->drawControl(QStyle::CE_CheckBox, &sob, &painter, this);
	pix.save("Check-Radio/check6.png",0,100);
	
	painter.end();
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	style()->drawControl(QStyle::CE_RadioButton, &sob, &painter, this);
	pix.save("Check-Radio/option6.png",0,100);
	
	painter.end();
	pix=QPixmap(93,22);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//toolbutton
	sotb.state|= QStyle::State_AutoRaise;
	sotb.iconSize=QSize(5,5);
	sotb.rect=QRect(0,0,93,22);
	style()->drawPrimitive(QStyle::PE_PanelButtonTool, &sotb, &painter, this);
		
	painter.end();
	pix.save("Toolbar/toolbutton-normal.png",0, 100);
	pix.save("Toolbar/toolbutton-default.png",0, 100);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//toolbutton mouseOver
	sotb.state|= QStyle::State_MouseOver;
	style()->drawPrimitive(QStyle::PE_PanelButtonTool, &sotb, &painter, this);
	
	painter.end();
	pix.save("Toolbar/toolbutton-prelight.png",0, 100);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	sotb.state|= QStyle::State_Sunken;
	style()->drawPrimitive(QStyle::PE_PanelButtonTool, &sotb, &painter, this);
	
	painter.end();
	pix.save("Toolbar/toolbutton-pressed.png",0, 100);
	pix.save("Toolbar/toolbutton-toggled.png",0, 100);
	pix=QPixmap(100,2);
	pix.fill(Qt::transparent);
	
	painter.begin(&pix);
	
	
	//toolbar separator
	so.initFrom(this);
	so.rect=QRect(0,0,100,2);
	style()->drawPrimitive(QStyle::PE_IndicatorToolBarSeparator, &so, &painter, this);
	
	painter.end();
	pix.save("Lines/line-h.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Lines/line-v.png",0,100);
	pix=QPixmap(24,14);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	so.rect=QRect(0,0,24,14);
	style()->drawPrimitive(QStyle::PE_IndicatorToolBarHandle, &so, &painter, this);
	
	painter.end();
	pix.save("Handles/handle-h.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Handles/handle-v.png",0,100);
	pix=QPixmap(300,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//progressBars
	sopb.maximum=100;
	sopb.progress=100;
	sopb.rect=QRect(0,0,300,30);
	style()->drawControl(QStyle::CE_ProgressBarGroove, &sopb, &painter, this);
	pix.save("ProgressBar/trough-progressbar-horiz.png",0,100);
	
	painter.end();
	pix=pix.transformed(rota);
	pix.save("ProgressBar/trough-progressbar-vert.png",0,100);
	pix=QPixmap(300,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	style()->drawControl(QStyle::CE_ProgressBar, &sopb, &painter, this);
	pix.save("ProgressBar/progressbar-horiz.png",0,100);

	painter.end();
	pix=pix.transformed(rota);
	pix.save("ProgressBar/progressbar-vert.png",0,100);
	pix=QPixmap(75,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//tabs
	sot.shape = QTabBar::RoundedNorth;
	sot.position = QStyleOptionTab::Middle;
	sot.rect=QRect(0,0,75,30);
	style()->drawControl(QStyle::CE_TabBarTab, &sot, &painter, this);
	//style()->drawControl(QStyle::CE_TabBarTabShape, &sot, &painter, this);
	
	painter.end();
	pix=pix.copy(0,0,75,25);
	pix.save("Tabs/tab-top.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Tabs/tab-right.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Tabs/tab-bottom.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Tabs/tab-left.png",0,100);
	pix=QPixmap(75,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//tabs with highlight
	sot.state = QStyle::State_Selected; 
	style()->drawControl(QStyle::CE_TabBarTab, &sot, &painter, this);
	
	painter.end();pix=pix.copy(0,0,75,25);
	pix=pix.copy(0,0,75,25);
	pix.save("Tabs/tab-top-active.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Tabs/tab-right-active.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Tabs/tab-bottom-active.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Tabs/tab-left-active.png",0,100);
	pix=QPixmap(20,126);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//scrollbars
	sos.rect=QRect(0,0,20,126);
	style()->drawControl(QStyle::CE_ScrollBarSlider, &sos, &painter, this);
	
	painter.end();
	pix.save("Scrollbars/slider-vert.png",0,100);
	pix=pix.transformed(rota);
	pix=pix.copy(0,0,pix.width()-1, pix.height()-1);
	pix.save("Scrollbars/slider-horiz.png",0,100);
	pix=QPixmap(23,190);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	sos.rect=QRect(0,0,23,190);
	//sos.subControls=QStyle::SC_ScrollBarSubPage;
	style()->drawControl(QStyle::CE_ScrollBarSubPage, &sos, &painter, this);
	
	painter.end();
	pix=removeTransparency(&pix);
	pix.save("Scrollbars/trough-scrollbar-vert.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/trough-scrollbar-horiz.png",0,100);
	pix=QPixmap(16,20);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	sos.rect=QRect(0,0,16,20);
//	sos.backgroundColor=
	style()->drawControl(QStyle::CE_ScrollBarSubLine, &sos, &painter, this);
	
	painter.end();
	pix.save("Scrollbars/stepper-up.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/stepper-right.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/stepper-down.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/stepper-left.png",0,100);
	pix=QPixmap(20,126);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//scrollbar mouseOver
	sos.rect=QRect(0,0,20,126);
	sos.state|=QStyle::State_MouseOver;
	//sos.state=QStyle::State_HasFocus;
	style()->drawControl(QStyle::CE_ScrollBarSlider, &sos, &painter, this);
	
	painter.end();
	pix.save("Scrollbars/slider-vert-prelight.png",0,100);
	pix=pix.transformed(rota);
	pix=pix.copy(0,0,pix.width()-1, pix.height()-1);
	pix.save("Scrollbars/slider-horiz-prelight.png",0,100);
	pix=QPixmap(16,20);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	sos.rect=QRect(0,0,16,20);
	sos.state|=QStyle::State_MouseOver;
	style()->drawControl(QStyle::CE_ScrollBarSubLine, &sos, &painter, this);
	
	painter.end();
	pix.save("Scrollbars/stepper-up-prelight.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/stepper-right-prelight.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/stepper-down-prelight.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/stepper-left-prelight.png",0,100);
	pix=QPixmap(20,126);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	//scrollbar disabled
	sos.palette.setCurrentColorGroup(QPalette::Disabled); 
	sos.state &= ~QStyle::State_Enabled; 
	sos.rect=QRect(0,0,20,126);
	style()->drawControl(QStyle::CE_ScrollBarSlider, &sos, &painter, this);
	
	painter.end();
	pix.save("Scrollbars/slider-vert-insens.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/slider-horiz-insens.png",0,100);
	pix=QPixmap(16,20);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	sos.rect=QRect(0,0,16,20);
	style()->drawControl(QStyle::CE_ScrollBarSubLine, &sos, &painter, this);
	
	painter.end();
	pix.save("Scrollbars/stepper-up-insens.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/stepper-right-insens.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/stepper-down-insens.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Scrollbars/stepper-left-insens.png",0,100);
	pix=QPixmap(60,25);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	//menu
	somi.state|=QStyle::State_Selected;
	somi.rect=QRect(0,0,60,25);
	style()->drawControl(QStyle::CE_MenuBarItem, &somi, &painter, this);
	
	painter.end();
	pix.save("Menu-Menubar/menubar-item.png",0,100);
	pix=QPixmap(100,24);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	somi.rect=QRect(0,0,100,24);
	style()->drawControl(QStyle::CE_MenuItem, &somi, &painter, this);
	
	painter.end();
	pix.save("Menu-Menubar/menuitem.png",0,100);
	pix=QPixmap(100,2);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	somi.rect=QRect(0,0,100,2);
	somi.menuItemType=QStyleOptionMenuItem::Separator;
	style()->drawControl(QStyle::CE_MenuItem, &somi, &painter, this);
	
	painter.end();
 	pix.save("Menu-Menubar/menu-separator.png",0,100);	
	pix=QPixmap(20,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	//sliders
	sos.palette.setCurrentColorGroup(QPalette::Active); 
	sos.state=QStyle::State_Enabled;
	sos.subControls=QStyle::SC_SliderHandle;
	sos.rect=QRect(0,0,20,30);
	style()->drawComplexControl(QStyle::CC_Slider, &sos, &painter, this);
	
	painter.end();
	pix=pix.copy(style()->subControlRect(QStyle::CC_Slider,&sos,QStyle::SC_SliderHandle));
	pix.save("Range/slider-horiz.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Range/slider-vert.png",0,100);
	pix=QPixmap(20,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	sos.state|=QStyle::State_MouseOver;
	style()->drawComplexControl(QStyle::CC_Slider, &sos, &painter, this);
	
	painter.end();
	pix=pix.copy(style()->subControlRect(QStyle::CC_Slider,&sos,QStyle::SC_SliderHandle));
	pix.save("Range/slider-horiz-prelight.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Range/slider-vert-prelight.png",0,100);
	pix=QPixmap(19,27);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	/*sos.state=QStyle::State_Enabled;
	sos.palette.setCurrentColorGroup(QPalette::Disabled);
	sos.rect=QRect(330,75,20,30);
	style()->drawComplexControl(QStyle::CC_Slider, &sos, &painter, this);*/
	
	sos.subControls=QStyle::SC_SliderGroove;
	sos.palette.setCurrentColorGroup(QPalette::Active);
	sos.rect=QRect(0,0,19,27);
	style()->drawComplexControl(QStyle::CC_Slider, &sos, &painter, this);
	
	painter.end();
	pix=pix.copy(style()->subControlRect(QStyle::CC_Slider,&sos,QStyle::SC_SliderGroove));
	pix.save("Range/trough-horizontal.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Range/trough-vertical.png",0,100);
	pix=QPixmap(15,16);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	//pix=wpix.copy(QRect(438,119,9,10));
	//pix=pix.scaled(9,8, Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
	
	//background
	//so.rect=QRect(5,5,100,100);
	//style()->drawPrimitive(QStyle::PE_PanelMenuBar, &somi, &painter, this);
	//arrows
	so.rect=QRect(0,0,15,16);
	style()->drawPrimitive(QStyle::PE_IndicatorArrowUp, &so, &painter, this);
	
	painter.end();
	pix.save("Arrows/arrow-up.png",0,100);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	so.rect=QRect(0,0,15,16);
	style()->drawPrimitive(QStyle::PE_IndicatorArrowDown, &so, &painter, this);
	
	painter.end();
	pix.save("Arrows/arrow-down-prelight.png",0,100);
	pix.save("Arrows/arrow-down.png",0,100);
	pix.save("Combo/combo-arrow.png",0,100);
	pix.save("Combo/combo-arrow-prelight.png",0,100);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	so.rect=QRect(0,0,15,16);
	style()->drawPrimitive(QStyle::PE_IndicatorArrowLeft, &so, &painter, this);
	
	painter.end();
	pix.save("Arrows/arrow-left-prelight.png",0,100);
		pix.save("Arrows/arrow-left.png",0,100);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	so.rect=QRect(0,0,15,16);
	style()->drawPrimitive(QStyle::PE_IndicatorArrowRight, &so, &painter, this);
	
	painter.end();
	//pix=removeTransparency(&pix,false);
	pix.save("Arrows/arrow-right-prelight.png",0,100);
	pix.save("Arrows/arrow-right-norm.png",0,100);
	pix.save("Arrows/arrow-right.png",0,100);
	pix.save("Menu-Menubar/menu-arrow.png",0,100);
	pix.save("Menu-Menubar/menu-arrow-prelight.png",0,100);
	pix=QPixmap(77,25);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	
	
	//so.palette.setCurrentColorGroup(QPalette::Disabled);
	//so.rect=QRect(435,135,15,16);
	//style()->drawPrimitive(QStyle::PE_IndicatorArrowDown, &so, &painter, this);
	
	//table
	soh.rect=QRect(0,0,77,25);
	style()->drawControl(QStyle::CE_Header, &soh, &painter, this);
	
	painter.end();
	pix.save("ListHeaders/list_header.png",0,100);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	soh.state|=QStyle::State_MouseOver;
	soh.rect=QRect(0,0,77,25);
	style()->drawControl(QStyle::CE_Header, &soh, &painter, this);
	
	painter.end();
	pix.save("ListHeaders/list_header-prelight.png",0,100);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	soh.state&=~QStyle::State_Enabled;
	soh.palette.setCurrentColorGroup(QPalette::Disabled);
	soh.rect=QRect(0,0,77,25);
	style()->drawControl(QStyle::CE_Header, &soh, &painter, this);
	
	painter.end();
	pix.save("ListHeaders/list_header-pressed.png",0,100);
	pix=QPixmap(25,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	//spinboxes
	spb.rect=QRect(0,0,25,30);
	spb.state=QStyle::State_Enabled;
	spb.subControls=QStyle::SC_SpinBoxUp;
	spb.subControls|=QStyle::SC_SpinBoxDown;
	style()->drawComplexControl(QStyle::CC_SpinBox, &spb,&painter,this);
	
	painter.end();
	wpix=pix.copy(style()->subControlRect(QStyle::CC_SpinBox,&spb,QStyle::SC_SpinBoxUp));
	wpix.save("Spin/spin-up.png",0,100);
	pix=pix.copy(style()->subControlRect(QStyle::CC_SpinBox,&spb,QStyle::SC_SpinBoxDown));
	pix.save("Spin/spin-down.png",0,100);
	pix=QPixmap(25,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	spb.state=QStyle::State_HasFocus;
	//style()->drawComplexControl(QStyle::CC_SpinBox, &spb, &painter, this);
	//style()->drawPrimitive(QStyle::PE_IndicatorSpinUp, &so, &painter, this);
	style()->drawComplexControl(QStyle::CC_SpinBox, &spb,&painter,this);
	
	painter.end();
	wpix=pix.copy(style()->subControlRect(QStyle::CC_SpinBox,&spb,QStyle::SC_SpinBoxUp));
	wpix.save("Spin/spin-up-prelight.png",0,100);
	pix=pix.copy(style()->subControlRect(QStyle::CC_SpinBox,&spb,QStyle::SC_SpinBoxDown));
	pix.save("Spin/spin-down-prelight.png",0,100);
	pix=QPixmap(25,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);	
	
	//spb.state&=~QStyle::State_Enabled;
	spb.palette.setCurrentColorGroup(QPalette::Disabled);
	//style()->drawComplexControl(QStyle::CC_SpinBox, &spb, &painter, this);
	style()->drawComplexControl(QStyle::CC_SpinBox, &spb,&painter,this);
		
	painter.end();
	wpix=pix.copy(style()->subControlRect(QStyle::CC_SpinBox,&spb,QStyle::SC_SpinBoxUp));
	wpix.save("Spin/spin-up-disable.png",0,100);
	pix=pix.copy(style()->subControlRect(QStyle::CC_SpinBox,&spb,QStyle::SC_SpinBoxDown));
	pix.save("Spin/spin-down-disable.png",0,100);
	pix=QPixmap(200,200);
	pix.fill(Qt::transparent);
	//pix.fill(pal.color(QPalette::Window));
	painter.begin(&pix);	
		
	sotwf.rect=QRect(0,0,200,200);
	sotwf.leftCornerWidgetSize=QSize(1,1);
	sotwf.rightCornerWidgetSize=QSize(1,1);
	sotwf.tabBarSize=QSize(1,1);
	style()->drawPrimitive(QStyle::PE_FrameTabWidget, &sotwf, &painter, this);
	
	painter.end();
	pix.save("Tabs/notebook_top_flat.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Tabs/notebook_right_flat.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Tabs/notebook_bottom_flat.png",0,100);
	pix=pix.transformed(rota);
	pix.save("Tabs/notebook_left_flat.png",0,100);
	pix=QPixmap(79,22);
	pix.fill(Qt::transparent);
	//pix.fill(pal.color(QPalette::Window));
	//pix.fill(Qt::white);
	painter.begin(&pix);
	
	//qDebug()<<menuOption->state;
	//style()->drawControl(QStyle::CE_MenuItem, &ooo, &painter, this);
	//style()->drawPrimitive(QStyle::PE_FrameMenu, &sof3, &painter, this);
	
	//qDebug()<<bool(somi.state & QStyle::State_Enabled);
	//somi.state&=~QStyle::State_Selected;
	//somi.state|=QStyle::State_On;
	//somi.rect=QRect(0,0,100,24);
	//somi.menuRect=QRect(0,0,200,200);
	//style()->drawControl(QStyle::CE_MenuBarEmptyArea, &somi, &painter, this);
	
	//QStyleHintReturnVariant * retData = new QStyleHintReturnVariant();
	//style()->styleHint(QStyle::SH_GUIStyle,0,0,retData);
	//qDebug()<<retData->variant.toString();
	
	sof3.rect=QRect(0,0,79,22);
	sof3.lineWidth=1;
	sof3.midLineWidth=1;
	sof3.frameShape=QFrame::Box;
 	sof3.state=QStyle::State_Sunken;
	sof3.state|=QStyle::State_Enabled;
	
	style()->drawPrimitive(QStyle::PE_FrameLineEdit, &sof3, &painter, this);
	
	painter.end();
	pix=removeTransparency(&pix);
	pix.save("Shadows/text-entry.png",0,100);
	pix.save("Shadows/text.png",0,100);
	pix.save("Shadows/entry-shadow-in.png",0,100);
	pix=QPixmap(79,22);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	sof3.state|=QStyle::State_HasFocus;
	style()->drawPrimitive(QStyle::PE_FrameLineEdit, &sof3, &painter, this);
	
	painter.end();
	pix=removeTransparency(&pix);
	pix.save("Shadows/text-entry-focused.png",0,100);
	pix=QPixmap(17,17);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	//size grip
	sosg.rect=QRect(0,0,17,17);
	sosg.corner=Qt::BottomRightCorner;
	style()->drawControl(QStyle::CE_SizeGrip,&sosg,&painter,this);
	
	painter.end();
	pix.save("Handles/resize_grip.png",0,100);
	pix = QPixmap(100,100);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	sof3.state&=~QStyle::State_HasFocus;
	sof3.frameShape=QFrame::StyledPanel;
	sof3.rect = QRect(0,0,100,100);
	style()->drawControl(QStyle::CE_ShapedFrame, &sof3,&painter,this);
	//style()->drawcomplexControl(QStyle::CC,&sot,&painter,this);
	
	painter.end();
	pix=removeTransparency(&pix);
	pix.save("Shadows/shadow-in.png",0,100);
	pix.save("Shadows/shadow-out.png",0,100);
	pix.save("Frame-Gap/frame1.png",0,100);
	pix = QPixmap(15,15);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	
	//expander
	so.initFrom(this);
	so.state=QStyle::State_Children;
	so.rect=QRect(0,0,15,15);
	style()->drawPrimitive(QStyle::PE_IndicatorBranch, &so, &painter, this);
	
	painter.end();
	pix.save("Expander/expander-normal-c.png",0,100);
	pix.save("Expander/expander-active-c.png",0,100);
	pix.save("Expander/expander-normal-sc.png",0,100);
	pix.save("Expander/expander-active-sc.png",0,100);
	pix = QPixmap(15,15);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	so.state|=QStyle::State_MouseOver;
	style()->drawPrimitive(QStyle::PE_IndicatorBranch, &so, &painter, this);
	
	painter.end();
	pix.save("Expander/expander-prelight-c.png",0,100);
	pix.save("Expander/expander-prelight-sc.png",0,100);
	pix = QPixmap(15,15);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	so.state&=~QStyle::State_MouseOver;
	so.palette.setCurrentColorGroup(QPalette::Disabled);
	
	painter.end();
	pix.save("Expander/expander-insens-c.png",0,100);
	pix.save("Expander/expander-insens-sc.png",0,100);
	pix = QPixmap(15,15);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	so.initFrom(this);
	so.state=QStyle::State_Children;
	so.state|=QStyle::State_Open;
	so.rect=QRect(0,0,15,15);
	
	style()->drawPrimitive(QStyle::PE_IndicatorBranch, &so, &painter, this);
	
	painter.end();
	pix.save("Expander/expander-normal-e.png",0,100);
	pix.save("Expander/expander-active-e.png",0,100);
	pix.save("Expander/expander-normal-se.png",0,100);
	pix.save("Expander/expander-active-se.png",0,100);
	pix = QPixmap(15,15);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	so.state|=QStyle::State_MouseOver;
	style()->drawPrimitive(QStyle::PE_IndicatorBranch, &so, &painter, this);
	
	painter.end();
	pix.save("Expander/expander-prelight-e.png",0,100);
	pix.save("Expander/expander-prelight-se.png",0,100);
	pix = QPixmap(15,15);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	so.palette.setCurrentColorGroup(QPalette::Disabled);
	
	painter.end();
	pix.save("Expander/expander-insens-e.png",0,100);
	pix.save("Expander/expander-insens-se.png",0,100);
	pix = QPixmap(80,30);
	pix.fill(Qt::transparent);
	painter.begin(&pix);
	
	QStyleOptionFocusRect focus;
	//focus.initFrom(this);
	focus.state=QStyle::State_KeyboardFocusChange;
	focus.rect=QRect(0,0,70,20);
	focus.backgroundColor=Qt::white;
	style()->drawPrimitive(QStyle::PE_FrameFocusRect, &focus, &painter, this);
	
	painter.end();
	pix.save("test.png",0,100);
	
	rota.reset();
}

void mainwin::applyIco()
{
	//icons copying
	kit=KIconTheme(KIconTheme::current()).dir();
	for (i=0; i<5; i++)
	{
		if (i==0)	
			isize = "16x16";
		if (i==1)
			isize = "22x22";
		if (i==2)
			isize = "32x32";
		if (i==3)
			isize = "48x48";
		if (i==4)
			isize = "64x64";
		iname = "/actions/";
		iconCopy("dialog-close","gtk-close");
		iconCopy("dialog-ok","gtk-ok");
		sym("gtk-ok","gtk-yes");
		iconCopy("dialog-cancel","gtk-cancel");
		iconCopy("dialog-ok-apply","gtk-apply");
		iconCopy("go-previous","gtk-go-back-ltr");
		iconCopy("go-next","gtk-go-forward-ltr");
		iconCopy("go-home","gtk-home");
		iconCopy("go-up","gtk-go-up");
		iconCopy("go-down","gtk-go-down");
		iconCopy("go-top","gtk-go-top");
		iconCopy("view-refresh","gtk-refresh");
		iconCopy("process-stop","gtk-stop");
		iconCopy("list-add","gtk-add");
		iconCopy("edit-find","gtk-find");
		iconCopy("edit-find-and-replace","gtk-find-and-replace");
		iconCopy("edit-copy","gtk-copy");
		iconCopy("edit-paste","gtk-paste");
		iconCopy("edit-delete","gtk-delete");
		iconCopy("edit-cut","gtk-cut");
		iconCopy("edit-undo","gtk-undo");
		iconCopy("edit-redo","gtk-redo");
		iconCopy("edit-select-all","gtk-select-all");
		iconCopy("edit-find-replace","gtk-find-and-replace");
		iconCopy("application-exit","application-exit");
		sym("application-exit", "gtk-quit");
		iconCopy("document-open","gtk-open");
		iconCopy("document-print","gtk-print");
		iconCopy("document-print-preview","gtk-print-preview");
		iconCopy("document-save","gtk-save");
		iconCopy("document-save-as","gtk-save-as");
		iconCopy("document-properties","gtk-properties");
		iconCopy("document-revert","gtk-revert-to-saved-ltr");
		iconCopy("window-new","window-new");
		iconCopy("tab-new","tab-new");
		iconCopy("folder-new","folder-new");
		iconCopy("file-new","file-new");
		iconCopy("configure","gtk-preferences");
		iconCopy("help-contents","gtk-help");
		iconCopy("help-about","gtk-about");
		iconCopy("zoom-in","gtk-zoom-in");
		iconCopy("zoom-out","gtk-zoom-out");
		iconCopy("zoom-original","gtk-zoom-100");
		iconCopy("zoom-fit-best","gtk-zoom-fit");
		iconCopy("svn-update","system-upgrade");
		
		iname="/places/";
		iconCopy("folder","folder");
		sym("folder","gtk-directory");
		sym("folder","folder-saved-search");
		sym("folder","application-x-gnome-saved-search.png");
		sym("folder","gnome-fs-directory");
		iconCopy("folder-remote","folder-remote");
		iconCopy("network-workgroup","network-workgroup");
		iconCopy("user-home","user-home");
		sym("user-home","gnome-fs-home");
		iconCopy("user-desktop","user-desktop");
		iconCopy("user-trash","user-trash");
		
		iname="/devices/";
		iconCopy("drive-harddisk","drive-harddisk");
		sym("drive-harddisk","gtk-harddisk");
		sym("drive-harddisk","gnome-dev-harddisk");
		sym("drive-harddisk","harddrive");
		iconCopy("drive-removable-media","drive-removable-media");
		iconCopy("media-floppy","media-floppy");
		sym("media-floppy","gtk-floppy");
		iconCopy("drive-optical","drive-optical");
		sym("drive-optical","gtk-cdrom");
		iconCopy("printer","printer");
		iconCopy("computer","computer");
		sym("computer","gnome-dev-computer");
		sym("computer","system");
		sym("computer","gnome-fs-client");
		
		iname="/status/";
		iconCopy("user-trash-full","user-trash-full");
		iconCopy("dialog-warning","gtk-dialog-warning");		
	}

	QProcess::execute("gtk-update-icon-cache -f "+QDir::homePath()+"/.icons/gk4ico");
	toFile();
}

void mainwin::iconCopy(QString name,QString newname)
{
	if (QFile(QDir::homePath()+"/.icons/gk4ico/"+isize+iname+newname+".png").exists())
		QFile(QDir::homePath()+"/.icons/gk4ico/"+isize+iname+newname+".png").remove();
	if (QFile(kit+isize+iname+name+".png").exists())
		QFile(kit+isize+iname+name+".png").copy(QDir::homePath()+"/.icons/gk4ico/"+isize+iname+newname+".png");
	else
		QFile(defkit->dir()+isize+iname+name+".png").copy(QDir::homePath()+"/.icons/gk4ico/"+isize+iname+newname+".png");
}

void mainwin::sym(QString name,QString newname)
{
	if (QFile(QDir::homePath()+"/.icons/gk4ico/"+isize+iname+newname+".png").exists())
		QFile(QDir::homePath()+"/.icons/gk4ico/"+isize+iname+newname+".png").remove();
	QProcess::execute("ln -s "+QDir::homePath()+"/.icons/gk4ico/"+isize+iname+name+".png "+QDir::homePath()+"/.icons/gk4ico/"+isize+iname+newname+".png");
}

void mainwin::toFile()
{
	sett->sync();
	colors.clear();
	/*0*/colors<<pal.color(QPalette::Base).name();
	/*1*/colors<<pal.color(QPalette::Disabled, QPalette::Base).name();
	/*2*/colors<<pal.color(QPalette::Text).name();
	/*3*/colors<<pal.color(QPalette::Highlight).name();
	/*4*/colors<<pal.color(QPalette::HighlightedText).name();
	/*5*/colors<<pal.color(QPalette::Window).name();
	/*6*/colors<<pal.color(QPalette::Disabled,QPalette::Window).name();
	/*7*/colors<<pal.color(QPalette::Disabled,QPalette::WindowText).name();
	/*8*/colors<<pal.color(QPalette::WindowText).name();
	/*9*/colors<<pal.color(QPalette::Disabled,QPalette::Text).name();
	 if (fileOpen==false)
	 {
		 QString varstr;
		 varstr = KStandardDirs::locate("config", "gtkrc-2.0");
		 if (varstr.isNull())
			varstr=KGlobal::dirs()->localkdedir()+"share/config/gtkrc";
		 file.setFileName(varstr);
		 varstr = KStandardDirs::locate("config", "gtkrc");
		 if (varstr.isNull())
			varstr=KGlobal::dirs()->localkdedir()+"share/config/gtkrc";
		 varfile.setFileName(varstr);
	 }
	file.setPermissions(QFile::WriteOwner);
	varfile.setPermissions(QFile::WriteOwner);
	file.remove();
	if (file.open(QFile::WriteOnly))
	{
		fileOpen=true;
		QTextStream out(&file);
		if (sett->value("StyleIndex").toString()!="0")
		{
			out<<"include \"/usr/share/themes/"<<sett->value("StyleText").toString()<<"/gtk-2.0/gtkrc\""<<endl;
			out<<"include \""<<QDir::homePath()<<"/.themes/"<<sett->value("StyleText").toString()<<"/gtk-2.0/gtkrc\""<<endl;
		}else{
			out<<"include \""<<QDir::homePath()<<"/.themes/qt4/gtk-2.0/gtkrc\""<<endl;
		}
		if (sett->value("ApplyColors").toString()=="2")
		{
			out<<"style \"user\""<<endl;
			out<<"{ "<<endl;
			out<<"fg[NORMAL] = \""<<colors.at(8)<<"\""<<endl;
			out<<"bg[NORMAL] = \""<<colors.at(5)<<"\""<<endl;
			out<<"text[NORMAL] = \""<<colors.at(2)<<"\""<<endl;
			out<<"base[NORMAL] = \""<<colors.at(0)<<"\""<<endl;
			
			out<<"fg[ACTIVE] = \""<<colors.at(8)<<"\""<<endl;
			out<<"bg[ACTIVE] = \""<<colors.at(5)<<"\""<<endl;
			out<<"text[ACTIVE] = \""<<colors.at(2)<<"\""<<endl;
			out<<"base[ACTIVE] = \""<<colors.at(0)<<"\""<<endl;
		
			out<<"fg[PRELIGHT] = \""<<colors.at(8)<<"\""<<endl;
			out<<"bg[PRELIGHT] = \""<<colors.at(5)<<"\""<<endl;
			out<<"text[PRELIGHT] = \""<<colors.at(4)<<"\""<<endl;
			out<<"base[PRELIGHT] = \""<<colors.at(3)<<"\""<<endl;
		
			out<<"fg[SELECTED] = \""<<colors.at(8)<<"\""<<endl;
			out<<"bg[SELECTED] = \""<<colors.at(5)<<"\""<<endl;
			out<<"text[SELECTED] = \""<<colors.at(4)<<"\""<<endl;
			out<<"base[SELECTED] = \""<<colors.at(3)<<"\""<<endl;
			
			out<<"fg[INSENSITIVE] = \""<<colors.at(7)<<"\""<<endl;
			out<<"bg[INSENSITIVE] = \""<<colors.at(6)<<"\""<<endl;
			out<<"text[INSENSITIVE] = \""<<colors.at(9)<<"\""<<endl;
			out<<"base[INSENSITIVE] = \""<<colors.at(1)<<"\""<<endl;
			out<<"GtkTreeView::odd_row_color=\""<<pal.color(QPalette::Base).name()<<"\""<<endl;
			out<<"GtkTreeView::even_row_color=\""<<pal.color(QPalette::AlternateBase).name()<<"\""<<endl;
			out<<"}"<<endl;
			out<<"widget_class \"*\" style \"user\""<<endl;
			
			out<<"style \"tooltips\""<<endl;
			out<<"{ "<<endl;
			out<<"bg[NORMAL] = \""<<pal.color(QPalette::ToolTipBase).name()<<"\""<<endl;
			out<<"fg[NORMAL] = \""<<pal.color(QPalette::ToolTipText).name()<<"\""<<endl;
			out<<"}"<<endl;
			out<<"widget \"gtk-tooltips\" style \"tooltips\""<<endl;
			if (sett->value("UseSpecialColors").toBool())
			{
				out<<"style \"menuitem\""<<endl;
				out<<"{"<<endl;
				out<<"fg[NORMAL] = \""<<sett->value("MenuTextColor").value<QColor>().name()<<"\""<<endl;
				out<<"fg[PRELIGHT] = \""<<sett->value("MenuTextColorMO").value<QColor>().name()<<"\""<<endl;
				out<<"fg[SELECTED] = \""<<sett->value("MenuTextColorMO").value<QColor>().name()<<"\""<<endl;
				out<<"fg[ACTIVE] = \""<<sett->value("MenuTextColorMO").value<QColor>().name()<<"\""<<endl;
				out<<"}"<<endl;
				out<<"widget_class \"*MenuItem*\" style \"menuitem\""<<endl;	
				
				out<<"style \"menubar\""<<endl;
				out<<"{"<<endl;
				out<<"fg[NORMAL] = \""<<sett->value("MenuBarTextColor").value<QColor>().name()<<"\""<<endl;
				out<<"fg[PRELIGHT] = \""<<sett->value("MenuBarTextColorMO").value<QColor>().name()<<"\""<<endl;
				out<<"text[NORMAL] = \""<<sett->value("MenuBarTextColorMO").value<QColor>().name()<<"\""<<endl;
				out<<"text[PRELIGHT] = \""<<sett->value("MenuBarTextColorMO").value<QColor>().name()<<"\""<<endl;
				out<<"}"<<endl;
				out<<"widget_class \"*MenuBar*\" style \"menubar\""<<endl;
				out<<"class \"GtkMenuBar\" style \"menubar\""<<endl;
			}
		}
		out<<"#gtk-theme-name=\"qt4\""<<endl;
		if (sett->value("FontIndex").toString()!="0")
		{
			fs=sett->value("FontFamily").toString();
			fs+=" "+sett->value("FontWeight").toString();
			fs+=" "+sett->value("FontStyle").toString();
			fs+=" "+sett->value("FontSize").toString();
			fs=fs.simplified();
			out<<"gtk-font-name=\""<<sett->value("FontFamily").toString()<<" "<<" "<<sett->value("FontSize").toString()<<"\""<<endl;
		}
		else
		{	fs=QApplication::font().family();
			fs+=" "+fontWeight(QApplication::font().weight());
			fs+=" "+fontStyle(QApplication::font().style());
			fs+=" "+QString::number(QApplication::font().pointSize());
			fs=fs.simplified();
			out<<"gtk-font-name=\""<<fs<<"\""<<endl;
		}
		if (sett->value("IconIndex").toString()!="0")
			out<<"gtk-icon-theme-name=\""<<sett->value("IconText").toString()<<"\""<<endl;
		else 
			out<<"gtk-icon-theme-name=\"gk4ico\""<<endl;
		out<<"gtk-icon-sizes = \"panel-menu=16,16:panel=16,16:gtk-button=22,22:gtk-large-toolbar=22,22\"";
		file.flush();
		file.close();
	}
	file.setPermissions(QFile::ReadOwner | QFile::ReadGroup | QFile::ReadOther);
	varfile.remove();
	QProcess::execute("ln -s "+file.fileName()+" "+varfile.fileName());
}

QString mainwin::fontWeight(int i)
{
	if (i==25) return QString("Light");
	else if (i==50) return QString("");
	else if (i==63) return QString("DemiBold");
	else if (i==75) return QString("Bold");
	else if (i==87) return QString("Black");
	else return QString("Something wrong! Please, report a bug");
}

QString mainwin::fontStyle(int j)
{
	if (j==0) return QString("");
	else if (j==1) return QString("Italic");
	else if (j==2) return QString("Oblique");
	else return QString("Something wrong! Please, report a bug");
}

void mainwin::time()
{
	QTimer::singleShot(2000, this, SLOT(applyApp()));
}

QPixmap mainwin::removeTransparency(QPixmap *pixmap, bool symmetric)
{
	QImage img = pixmap->toImage();
	for (i=0; i<pixmap->width()-1; i++)
		if (qAlpha(img.pixel(i,pixmap->height()/2))>0)
			break;
	for (j=0; j<pixmap->height()-1; j++)
		if (qAlpha(img.pixel(pixmap->width()/2,j))>0)
			break;
	if (symmetric)
		return pix.copy(i,j,pixmap->width()-2*i,pixmap->height()-2*j);
	int m,n;
	for (m=pixmap->width()-1; m>0; m--)
		if (qAlpha(img.pixel(m,pixmap->height()/2))>0)
			break;
	for (n=pixmap->height()-1; n>0; n--)
		if (qAlpha(img.pixel(pixmap->width()/2,n))>0)
			break;
	return pix.copy(i,j,pixmap->width()-m+1,pixmap->height()-n+1);
}